var ConfigModel = Backbone.Model.extend({
	url : function() {
		return AJS.contextPath() + "/rest/resources/1.0/adminBoard/admin";
	}});

var ConfigFormView = Backbone.View.extend({
	
	el: '#adminForm',
	
	events: {
		"change #monday" : "mondayValueChanged",
		"change #tuesday" : "tuesdayValueChanged",
		"change #wednesday" : "wednesdayValueChanged",
		"change #thursday" : "thursdayValueChanged",
		"change #friday" : "fridayValueChanged",
		"change #saturday" : "saturdayValueChanged",
		"change #sunday" : "sundayValueChanged",
		"change #weeks-to-display" : "weeksToDisplayChanged",
		"change #display-mode" : "displayModeChanged",
		"change #color-fine" : "colorFineChanged",
		"change #color-light" : "colorLightChanged",
		"change #color-middle" : "colorMiddleChanged",
		"change #color-bad" : "colorBadChanged",
		"change #threshold-1" : "threshold1Changed",
		"change #threshold-2" : "threshold2Changed",
		"change #threshold-3" : "threshold3Changed",
		"click #admin-form-save-button" : "saveConfigValues",
	},

	initialize : function() {
		this.model.fetch();
		this.listenTo(this.model, 'sync', this.render);
	},
	
	render : function() {
		AJS.$("#monday").attr("value", this.model.get('mondayValue'));
		AJS.$("#tuesday").attr("value", this.model.get('tuesdayValue'));
		AJS.$("#wednesday").attr("value", this.model.get('wednesdayValue'));
		AJS.$("#thursday").attr("value", this.model.get('thursdayValue'));
		AJS.$("#friday").attr("value", this.model.get('fridayValue'));
		AJS.$("#saturday").attr("value", this.model.get('saturdayValue'));
		AJS.$("#sunday").attr("value", this.model.get('sundayValue'));
		AJS.$("#weeks-to-display").attr("value", this.model.get('weeksToDisplay'));
		AJS.$("#display-mode").attr("value", this.model.get('displayMode'));
		AJS.$("#color-fine").attr("value", this.model.get('colorFine'));
		AJS.$("#color-fine").attr("style", "background-color: "+this.model.get('colorFine'));
		AJS.$("#color-light").attr("value", this.model.get('colorLight'));
		AJS.$("#color-light").attr("style", "background-color: "+this.model.get('colorLight'));
		AJS.$("#color-middle").attr("value", this.model.get('colorMiddle'));
		AJS.$("#color-middle").attr("style", "background-color: "+this.model.get('colorMiddle'));
		AJS.$("#color-bad").attr("value", this.model.get('colorBad'));
		AJS.$("#color-bad").attr("style", "background-color: "+this.model.get('colorBad'));
		AJS.$("#threshold-1").attr("value", this.model.get('threshold1'));
		AJS.$("#threshold-2").attr("value", this.model.get('threshold2'));
		AJS.$("#threshold-3").attr("value", this.model.get('threshold3'));
		return this;	
	},
	
	saveConfigValues : function() {
		this.model.save();
		return false;
	},

	mondayValueChanged : function(event) {
		this.model.set('mondayValue', event.currentTarget.value);
	},

	tuesdayValueChanged : function(event) {
		this.model.set('tuesdayValue', event.currentTarget.value);
	},

	wednesdayValueChanged : function(event) {
		this.model.set('wednesdayValue', event.currentTarget.value);
	},

	thursdayValueChanged : function(event) {
		this.model.set('thursdayValue', event.currentTarget.value);
	},

	fridayValueChanged : function(event) {
		this.model.set('fridayValue', event.currentTarget.value);
	},

	saturdayValueChanged : function(event) {
		this.model.set('saturdayValue', event.currentTarget.value);
	},

	sundayValueChanged : function(event) {
		this.model.set('sundayValue', event.currentTarget.value);
	},

	weeksToDisplayChanged : function(event) {
		this.model.set('weeksToDisplay', event.currentTarget.value);
	},

	colorFineChanged : function(event) {
		this.model.set('colorFine', event.currentTarget.value);
	},

	colorLightChanged : function(event) {
		this.model.set('colorLight', event.currentTarget.value);
	},

	colorMiddleChanged : function(event) {
		this.model.set('colorMiddle', event.currentTarget.value);
	},

	colorBadChanged : function(event) {
		this.model.set('colorBad', event.currentTarget.value);
	},

	threshold1Changed : function(event) {
		this.model.set('threshold1', event.currentTarget.value);
	},

	threshold2Changed : function(event) {
		this.model.set('threshold2', event.currentTarget.value);
	},

	threshold3Changed : function(event) {
		this.model.set('threshold3', event.currentTarget.value);
	},

	displayModeChanged : function(event) {
		this.model.set('displayMode', event.currentTarget.value);
	}

});

jQuery(document).ready(function($) {
	var configModel = new ConfigModel();
	var configFormView = new ConfigFormView({model: configModel});
});
