define('aim/absence/view/AbsenceValueView',['aim/absence/view/SelectResourceView',
                                            'aim/absence/view/SelectFromView',
                                            'aim/absence/view/SelectToView',
                                            'aim/absence/view/ExtendFilterView',
                                            'aim/absence/view/SelectAbsenceValueView'
                                            ], function(
                                            		SelectResourceView,
                                            		SelectFromView,
                                            		SelectToView,
                                            		ExtendFilterView,
                                            		SelectAbsenceValueView) {
	var AbsenceValueView = Backbone.View.extend({
		
		el : '#add-absence-dialog',
		
		events: {
			"change #resource-single-select" : "resourceSelectChanged",
			"change #fromDate" : "fromChanged",
			"change #toDate" : "toChanged",
			"change #absenceValue" : "absenceValueChanged",
			"click #absencevalues-save-button" : "saveAbsenceValues",
			"click #absencevalues-cancel-button" : "cancelAbsenceValues"
		},
		
		initialize : function() {
			this.model.get('absenceValueModel').fetch();
			this.listenTo(this.model.get('absenceValueModel'), 'sync', this.render);
			var selectResourceView = new SelectResourceView({model: this.model.get('absenceValueModel')});
			var selectedFromDate = new SelectFromView({model: this.model.get('absenceValueModel')});
			var selectedToDate = new SelectToView({model: this.model.get('absenceValueModel')});
			var extendFilterView = new ExtendFilterView({model: this.model.get('absenceValueModel')});
			var selectedAbsenceValueDate = new SelectAbsenceValueView({model: this.model.get('absenceValueModel')});
		},
		
		render : function() {
			return this;		
		},
		
		saveAbsenceValues : function() {
			if(this.model.get('absenceValueModel').get('selectedResource') == 0)
				return this;
			var that = this;
			this.model.get('absenceValueModel').set('saved', "true");
			this.model.get('absenceValueModel').set('operation', "spreadInPeriod");

			this.model.get('absenceValueModel').save(null, {success:function(model, res, options) {
				that.model.get('newFilterModel').fetch();	
				that.model.get('absenceValueModel').fetch();
				that.model.get('contextModel').fetch();
			}});
			AJS.dialog2("#add-absence-dialog").hide();
//			AJS.messages.generic({
//			    title: AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.success.title"),
//			    fadeout: true,
//			    delay: 3000,
//			    duration: 2000,
//			    body: AJS.I18n.getText("naomi.templates.js.jirarp.absence.board.add.dialog.success.message")
//			});
		},

		cancelAbsenceValues : function() {
			AJS.dialog2("#add-absence-dialog").hide();
			this.model.get('absenceValueModel').fetch();
		},
		
		fromChanged : function(event) {
			var absenceValueModel = this.model.get('absenceValueModel');
			var value = event.currentTarget.value;
			absenceValueModel.set('from', value);
			absenceValueModel.set('selectedFromChanged', "true");
			absenceValueModel.save();
		},
		
		toChanged : function(event) {
			var absenceValueModel = this.model.get('absenceValueModel');
			var value = event.currentTarget.value;
			absenceValueModel.set('to', value);
			absenceValueModel.set('selectedToChanged', "true");
			absenceValueModel.save();
		},
		
		absenceValueChanged : function(event) {
			var absenceValueModel = this.model.get('absenceValueModel');
			var value = event.currentTarget.value;
			absenceValueModel.set('absenceValue', value);
			absenceValueModel.set('absenceValueChanged', "true");
			absenceValueModel.save();
		},
		
		resourceSelectChanged : function(event) {
//			var absenceValueModel = this.model.get('absenceValueModel');
//			var value = event.currentTarget.value;
//			absenceValueModel.set('selectedResource', value);	
//			absenceValueModel.set('selectedResourceChanged', "true");
//			absenceValueModel.save();
//			
			if(event.added){
				var value = event.added.id;
				this.model.get('absenceValueModel').set('selectedResource', value);	
				this.model.get('absenceValueModel').set('selectedResourceChanged', "true");
				this.model.get('absenceValueModel').save();
			}else if(event.removed){
				var value = 0;
				this.model.get('absenceValueModel').set('selectedResource', value);	
				this.model.get('absenceValueModel').set('selectedResourceChanged', "true");
				this.model.get('absenceValueModel').save();
			}

		}
	});
	return AbsenceValueView;
});