define('aim/assignment/view/BoardMainView',['aim/assignment/model/ChangePlanValueModel',
                                            'aim/assignment/view/SelectCalendarWeekView',
                                            'aim/assignment/view/SelectProjectResourceActionView'], function(
                                            		ChangePlanValueModel,
                                            		SelectCalendarWeekView,
                                            		SelectProjectRessourceActionView) {
	var BoardMainView = Backbone.View.extend({
		el : "#content",
		
		events: {
			"click #resourceContextButton" : "toggleResources",
			"click #projectContextButton" : "toggleProjects",
			"click #resourceOnlyContextButton" : "toggleOnlyResources",
			"click #dialog-add-plan-button" : "addPlanValues",
			"click #calendar-weeks-shift-left-button" : "calendarWeeksShiftLeft",
			"click #calendar-weeks-shift-right-button" : "calendarWeeksShiftRight",
			"change .inputweeks" : "edit",
			"change #calendar-week-select" : "jumpToCalendarWeek"
		},
		
		context : {},
		
		initialize : function() {
			var requests = new Array();
			AJS.$.ajaxSetup({
				beforeSend:function(event,xhr,options){
					requests.push(xhr);
					if(xhr.url.endsWith("/context") ){
						AJS.$('.spinner').spin();
						AJS.$('.spinner').addClass('naomi-spinner');
					}
				},
				complete:function(xhr,status){
					requests.pop(xhr);
					if(requests.length == 0){
						AJS.$('.spinner').spinStop();
						AJS.$('.spinner').removeClass('naomi-spinner');
					}
				}
			});	
			this.context.mode = constants.resourceMode;
			this.listenTo(this.model, 'sync', this.render);
			var selectCalendarWeekView = new SelectCalendarWeekView({model: this.model});
			this.model.fetch();
		},
		
		render : function() {
			focusedElementId = AJS.$(':focus').attr('id');
			var tmpOps = {};
			tmpOps.isResourceMode = this.context.mode;
			tmpOps.currentWeek = this.model.get('highlightedWeek');
			var pagePanelInner = this.$('#aui-page-panel-inner');
			pagePanelInner.html(Naomi.Templates.JiraRp.board(tmpOps, null, this.model.get('context')));
		    AJS.$('#' + focusedElementId).focus();
		    AJS.$('#' + focusedElementId).select();
		    var selectProjectRessourceActionView = new SelectProjectRessourceActionView({model: this.model}); 
//		    selectProjectRessourceActionView.render();
		    //dynamic action loading disabled because the link to the resource is not clear
//			var projectResourceActionCollection = new ProjectResourceActionCollection();
//			var selectProjectRessourceActionView = new SelectProjectRessourceActionView({model: projectResourceActionCollection});
//			projectResourceActionCollection.fetch();
			return this;
		},
		
		calendarWeeksShiftLeft : function() {
			this.model.set("calendarWeekShift",-1);
			this.model.set("calendarWeekShiftChanged","true");
			this.model.save();
		},
		
		calendarWeeksShiftRight : function() {
			this.model.set("calendarWeekShift",1);
			this.model.set("calendarWeekShiftChanged","true");
			this.model.save();
		},
		
		jumpToCalendarWeek : function(event) {
			this.model.set("calendarWeekShift",event.currentTarget.value);
			this.model.set("calendarWeekShiftChanged","true");
			this.model.save();
		},
		
		toggleOnlyResources : function() {
			if(this.context.mode == constants.resourceOnly) {
				return;
			}
			this.context.mode = constants.resourceOnly;
			this.$('#projectButtonLi').removeClass( 'aui-nav-selected' );
			this.$('#resourceButtonLi').removeClass( 'aui-nav-selected' );
			this.$('#resourceOnlyButtonLi').addClass( 'aui-nav-selected' );
			this.render();
		},
		
		toggleResources : function() {
			if(this.context.mode == constants.resourceMode) {
				return;
			}
			this.context.mode = constants.resourceMode;
			this.$('#projectButtonLi').removeClass( 'aui-nav-selected' );
			this.$('#resourceOnlyButtonLi').removeClass( 'aui-nav-selected' );
			this.$('#resourceButtonLi').addClass( 'aui-nav-selected' );
			this.render();
		},
		
		toggleProjects : function() {
			if(this.context.mode == constants.projectMode) {
				return;
			}			
			this.context.mode = constants.projectMode;
			this.$('#resourceButtonLi').removeClass( 'aui-nav-selected' );
			this.$('#resourceOnlyButtonLi').removeClass( 'aui-nav-selected' );
			this.$('#projectButtonLi').addClass( 'aui-nav-selected' );
			this.render();
		},
		
		addPlanValues : function() {
			
		    AJS.dialog2("#add-plan-value-dialog").show();
		},
		
		edit: function(event) {
			var that = this;
			focusedElementId = AJS.$(':focus').attr('id');
			if(event && event.currentTarget && event.currentTarget.id) {
				if(!event.currentTarget.value) return;
				var ids = event.currentTarget.id.split("-");
				if(ids && ids.length == 4) {
					var weekId = null;
					var projectId = null;
					var userId = null;
					_.each(ids, function(id, index) {
						switch(index) {
					    case 1:
					        weekId = id;
					        break;
					    case 2:
					        projectId = id;
					        break;
					    case 3:
					        userId = id;
					        break;
						}
					});
					var weeks = this.model.attributes.context.weeks;
					var selectedWeek;
					_.each( weeks, function( week ) {
					  if ( week.title == weekId ) {
						  selectedWeek=week;
					  }
					});

					var modelForSave = new ChangePlanValueModel();
					modelForSave.set('selectedProject', projectId);
					modelForSave.set('selectedResource', userId);
					modelForSave.set('operation', "spreadInWeek");
					modelForSave.set('year', selectedWeek.year);
					modelForSave.set('week', weekId);
					modelForSave.set('planValue', event.currentTarget.value);
					modelForSave.save(null, {success:function(model, res, options) {
						var context = that.model.get("context");
						var result = res;
						var kw = _.find(context.weeks, function(week) {
							if(week.title == weekId) {
								return true;
							} else {
								return false;
							}
						}); 
						
						var restSum =result.resourceRestSum;
						var sum = result.resourceSum;
						var inputValue = result.planValue;
						var projectSum = result.projectSum;
						var effectiveAssignmentLevel=result.effectiveAssignmentLevel;

						kw.projectSubSections[projectId].sectionValues[userId].sum = inputValue;
						kw.projectSubSections[projectId].sectionValues[userId].effectiveAssignmentLevel=effectiveAssignmentLevel;
						kw.projectSubSections[projectId].overallSum = projectSum;
						
						kw.resourceSubSections[userId].sectionValues[projectId].sum = inputValue;
						kw.resourceSubSections[userId].overallSum = sum;
						kw.resourceSubSections[userId].sectionValues[projectId].effectiveAssignmentLevel=effectiveAssignmentLevel;
						kw.resourceSubSections[userId].restSum=restSum;
						kw.resourceSubSections[userId].effectiveAssignmentLevel=effectiveAssignmentLevel;
						
						_.each(kw.projectSubSections, function(resourcePlaningProject) {
							if(resourcePlaningProject.sectionValues[userId]){
								resourcePlaningProject.sectionValues[userId].effectiveAssignmentLevel=effectiveAssignmentLevel;
							}
						});
						
//						_.each(kw.resourceSubSections[userId].sectionValues, function(section) {
//							section.restSum = restSum;
//						});
						that.render();
					}});	
					AJS.$('#' + focusedElementId).focus();
				    AJS.$('#' + focusedElementId).select();
				}
			}
		}
	});
	return BoardMainView;
});