define('aim/capacity/view/FilterPopupFooterView',['aim/capacity/model/CheckFilterNameModel'], function(CheckFilterNameModel) {
	var FilterPopupFooterView = Backbone.View.extend({
		el: '#filter-popup-footer',

		events: {
			"keyup #filterName": "changeFilterName",
		},
		
		initialize : function() {
			var newFilterModel = this.model;
			var tmpOps = {};
			this.listenTo(newFilterModel, 'sync', this.render);
			if(newFilterModel.get("filterId") != 0){
				tmpOps.edit="edit";
			}
			this.$el.html(Naomi.Templates.JiraRp.filterPopupFooter(tmpOps, null, null));
			return this;
		},
			
		render : function() {
			var newFilterModel = this.model;
			AJS.$("#filterName").val(newFilterModel.get("filterName"));
			return this;
		},
		
		changeFilterName : function(event) {
			var modelForSave = new CheckFilterNameModel();
			modelForSave.set('filterName', event.currentTarget.value);
			modelForSave.set('operation', 'checkFilterName');
			var that=this;
			modelForSave.save(null, {success:function(model, res, options) {
				that.model.set("message",res.message);
				var result = res;
				if(res.message == ""){
					AJS.$("#filterName").removeClass( 'naomi-input-error' );
					that.model.set("filterName", event.currentTarget.value);
					return this;
				}else{
					AJS.$("#filterName").addClass( 'naomi-input-error' );
					that.model.set("filterName", event.currentTarget.value);
					return this;
				}
			}});	
		}
		});
	return FilterPopupFooterView;
});